/***************************************************************************
***
***    Copyright 2005  Hon Hai Precision Ind. Co. Ltd.
***    All Rights Reserved.
***    No portions of this material shall be reproduced in any form without the
***    written permission of Hon Hai Precision Ind. Co. Ltd.
***
***    All information contained in this document is Hon Hai Precision Ind.  
***    Co. Ltd. company private, proprietary, and trade secret property and 
***    are protected by international intellectual property laws and treaties.
***
****************************************************************************/

#ifndef __FLASH_CONF_H
#define __FLASH_CONF_H

#define IMAGE_DL_ADDR       0x100000
#define KERNEL_RAM_ADDR     0x400000

typedef enum 
{
    PART_KERNEL,
    PART_ROOTFS,
    PART_TMETER1,
    PART_TMETER2,
    PART_POT,
    PART_BD,
    PART_NVRAM,
    PART_UBOOT
};

#define BOARD_ID_LEN        64
struct board_data
{
    unsigned char board_id[BOARD_ID_LEN];
    unsigned char lan_mac[6];
    unsigned char wan_mac[6];
};

extern unsigned long get_part_addr(int part_num);
extern unsigned long get_part_size(int part_num);

extern int get_eth_mac(unsigned char *lan_mac, unsigned char *wan_mac);
extern int verify_flash_image(void);
extern int decode_flash_image(void);
extern int verify_download_image(unsigned long image_addr);
extern int write_image_to_flash(unsigned long image_addr);

extern int power_led_control(int on_off);
extern int diag_led_control(int on_off);
extern int wlan_led_control(int on_off);
extern int wan_led_control(int on_off);
extern int check_reset(void);

extern void mdelay(int msec);

#endif
